/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.18_02 from the
 * contents of Warp.xs. Do not edit this file, edit Warp.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "Warp.xs"
#ifdef __cplusplus
extern "C" {
#endif

#define MIN_PERL_DEFINE 1

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#ifdef __cplusplus
}
#endif

/* Is time() portable everywhere?  Hope so!  XXX */

static double fallback_NVtime()
{ return time(0); }

static void fallback_U2time(U32 *ret)
{
  ret[0]=time(0);
  ret[1]=0;
}

/*-----------------*/

static int    Installed=0;
static double (*realNVtime)();
static void   (*realU2time)(U32 *);

static double Lost;    /** time relative to now */
static double Zero;    /** apply Scale from when? */
static double Scale;   /** speed of time (.5 == half speed) */

static void reset_warp()
{
    Lost=0;
    Zero=(*realNVtime)();
    Scale=1;
}

/*-----------------*/

static double warped_NVtime()
{
    double now = (*realNVtime)() - Lost;
    double delta = now - Zero;
    delta *= Scale;
    return Zero + delta;
}

static void warped_U2time(U32 *ret)
{
    /* performance doesn't matter enough for a native
       non-float implementation */
    double now = warped_NVtime();
    U32 unow = now;
    ret[0] = unow;
    ret[1] = (now - unow) * 1000000;
}

#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#line 77 "Warp.c"

XS(XS_Time__Warp_install_time_api); /* prototype to pass -Wmissing-prototypes */
XS(XS_Time__Warp_install_time_api)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Time::Warp::install_time_api", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 70 "Warp.xs"
{
    SV **svp;
    if (Installed) {
	warn("Time::Warp::install_time_api() called more than once");
	return;
    }
    Installed=1;
    svp = hv_fetch(PL_modglobal, "Time::NVtime", 12, 0);
    if (!svp) {
	warn("Time::Warp: Time::HiRes is not loaded --\n\tat best 1s time accuracy is available");
	hv_store(PL_modglobal, "Time::NVtime", 12,
		 newSViv((IV) fallback_NVtime), 0);
	hv_store(PL_modglobal, "Time::U2time", 12,
		 newSViv((IV) fallback_U2time), 0);
    }
    svp = hv_fetch(PL_modglobal, "Time::NVtime", 12, 0);
    if (!SvIOK(*svp)) croak("Time::NVtime isn't a function pointer");
    realNVtime = (double(*)()) SvIV(*svp);
    svp = hv_fetch(PL_modglobal, "Time::U2time", 12, 0);
    if (!SvIOK(*svp)) croak("Time::U2time isn't a function pointer");
    realU2time = (void(*)(U32*)) SvIV(*svp);
    hv_store(PL_modglobal, "Time::NVtime", 12,
	     newSViv((IV) warped_NVtime), 0);
    hv_store(PL_modglobal, "Time::U2time", 12,
	     newSViv((IV) warped_U2time), 0);

    reset_warp();
}
#line 120 "Warp.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Time__Warp_reset); /* prototype to pass -Wmissing-prototypes */
XS(XS_Time__Warp_reset)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Time::Warp::reset", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 102 "Warp.xs"
	reset_warp();
#line 140 "Warp.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Time__Warp_to); /* prototype to pass -Wmissing-prototypes */
XS(XS_Time__Warp_to)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Time::Warp::to", "when");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	double	when = (double)SvNV(ST(0));
#line 108 "Warp.xs"
{
    Lost += (warped_NVtime() - when) / Scale;
}
#line 163 "Warp.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Time__Warp_scale); /* prototype to pass -Wmissing-prototypes */
XS(XS_Time__Warp_scale)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 115 "Warp.xs"
{
    if (items == 0) {
	XPUSHs(sv_2mortal(newSVnv(Scale)));
    } else {
	Zero = warped_NVtime();
	Lost = 0;
	Scale = SvNV(ST(0));
	if (Scale < 0) {
	    warn("Sorry, Time::Warp cannot go backwards");
	    Scale = 1;
	}
	else if (Scale < .001) {
	    warn("Sorry, Time::Warp cannot stop time");
	    Scale = .001;
	}
    }
}
#line 199 "Warp.c"
	PUTBACK;
	return;
    }
}


XS(XS_Time__Warp_time); /* prototype to pass -Wmissing-prototypes */
XS(XS_Time__Warp_time)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Time::Warp::time", "");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 136 "Warp.xs"
{
    XPUSHs(sv_2mortal(newSVnv(warped_NVtime())));
}
#line 224 "Warp.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Time__Warp); /* prototype to pass -Wmissing-prototypes */
XS(boot_Time__Warp)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXSproto("Time::Warp::install_time_api", XS_Time__Warp_install_time_api, file, "");
        newXSproto("Time::Warp::reset", XS_Time__Warp_reset, file, "");
        newXSproto("Time::Warp::to", XS_Time__Warp_to, file, "$");
        newXSproto("Time::Warp::scale", XS_Time__Warp_scale, file, ";@");
        newXSproto("Time::Warp::time", XS_Time__Warp_time, file, "");
    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

